## genwqe-user 4.0.18

=== tools/Makefile ===
#
# Copyright 2015, International Business Machines
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include ../config.mk

DESTDIR ?= /usr
libs = ../lib/libDDCB.a ../lib/libzHW.a ../lib/libcard.a
LDLIBS += $(libs) -lpthread -lrt

genwqe_peek_objs = force_cpu.o
genwqe_poke_objs = force_cpu.o
genwqe_memcopy_objs = force_cpu.o
genwqe_cksum_objs = force_cpu.o
genwqe_echo_objs = force_cpu.o
genwqe_vpdupdate_objs = genwqe_vpd_common.o
genwqe_vpdconv_objs = genwqe_vpd_common.o

genwqe_memcopy_libs = -lz
genwqe_cksum_libs = -lz
genwqe_gzip_libs = ../lib/libzADC.a -ldl	# statically link our libz
genwqe_gunzip_libs = ../lib/libzADC.a -ldl	# statically link our libz
zlib_mt_perf_libs = ../lib/libzADC.a -ldl	# statically link our libz
gzFile_test_libs = -L../lib -lzADC -ldl		# dynamically link our libz

projs = genwqe_update genwqe_gzip genwqe_gunzip zlib_mt_perf genwqe_memcopy \
	genwqe_echo genwqe_peek genwqe_poke genwqe_cksum genwqe_vpdconv \
	genwqe_vpdupdate genwqe_csv2vpd genwqe_ffdc gzFile_test

ifdef WITH_LIBCXL
# genwqe_maint is only used with CAPI support.
projs += genwqe_maint genwqe_loadtree
CAPI_INSTALL=capi_install

# If we are bundling, we need to link statically.  Otherwise, go dynamic.
ifeq ($(BUNDLE_LIBCXL),1)
LDLIBS += $(libcxl_a)
else
LDLIBS += -lcxl
endif # !CONFIG_LIBCXL_PATH

endif # WITH_LIBCXL

all: $(projs)

genwqe_memcopy: force_cpu.o
genwqe_vpdconv genwqe_vpdupdate: genwqe_vpd_common.o

$(projs): $(libs)

objs = force_cpu.o genwqe_vpd_common.o $(projs:=.o)

manpages = $(projs:=.1.gz)

manpages: all $(manpages)

genwqe_gunzip.o: genwqe_gzip.c
	$(CC) -c $< $(CPPFLAGS) $(CFLAGS) -o $@

### Deactivate existing implicit rule
%: %.c
%: %.sh

### Generic rule to build a tool
%: %.o
	$(CC) $(LDFLAGS) $@.o $($(@)_objs) $($(@)_libs) $(LDLIBS) -o $@

%.o: %.c $(libs)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

### Setting LD_LIBRARY_PATH helps to try tools with dynamic linkage
%.1: %
	LD_LIBRARY_PATH=../lib $(HELP2MAN) -N --output=$@ \
		--name "IBM Hardware Accelerator Tool." ./$<

%.1.gz: %.1
	gzip --best -c $< > $@

#
# Tools for card maintenance
#
install_release_tools: all
	@mkdir -p $(DESTDIR)/bin
	cp -uv genwqe_peek genwqe_poke genwqe_memcopy genwqe_echo \
		genwqe_update \
		$(DESTDIR)/bin

#
# Example tools and testcases
#   gzip and gunzip go into special directory, since they should not be
#   in regular path to be mixed up with distro version of those tools.
#   Nevertheless we need them to accelerate tar for example with our
#   hardware accelerated version of gzip/gunzip.
#
install_gzip_tools: all
	install -D -m 755 genwqe_gzip    -T $(DESTDIR)/bin/genwqe_gzip
	install -D -m 755 genwqe_gunzip  -T $(DESTDIR)/bin/genwqe_gunzip
	install -D -m 755 zlib_mt_perf   -T $(DESTDIR)/bin/zlib_mt_perf
	install -D -m 755 genwqe_mt_perf -T $(DESTDIR)/bin/genwqe_mt_perf
	install -D -m 755 genwqe_test_gz -T $(DESTDIR)/bin/genwqe_test_gz

uninstall_gzip_tools:
	$(RM) $(DESTDIR)/bin/genwqe_gzip \
	      $(DESTDIR)/bin/genwqe_gunzip \
	      $(DESTDIR)/bin/zlib_mt_perf \
	      $(DESTDIR)/bin/genwqe_mt_perf \
	      $(DESTDIR)/bin/genwqe_test_gz

install_manpages: $(manpages)
	@mkdir -p $(MAN_INSTALL_PATH)
	cp -uv $(manpages) $(MAN_INSTALL_PATH)

install_release_manpages: $(manpages)
	@mkdir -p $(MAN_INSTALL_PATH)

	cp -uv genwqe_memcopy.1 genwqe_echo.1 genwqe_update.1 \
		$(DESTDIR)/man/man1
	cp -uv genwqe_memcopy.1 genwqe_echo.1 genwqe_update.1 \
		$(MAN_INSTALL_PATH)

uninstall_manpages:
	@for f in $(manpages) ; do				\
		echo "removing $(DESTDIR)/man/man1/$$f ...";	\
		$(RM) $(DESTDIR)/man/man1/$$f;			\
	done

capi_install: genwqe_maint
	install -D -m 755 genwqe_maint -T $(DESTDIR)/bin/genwqe_maint
	install -D -m 755 genwqe_loadtree -T $(DESTDIR)/bin/genwqe_loadtree

install: install_gzip_tools install_manpages $(CAPI_INSTALL)
	@mkdir -p $(DESTDIR)/bin
	install -D genwqe_update -T $(DESTDIR)/bin/genwqe_update
	install -D -m 755 genwqe_memcopy   -T $(DESTDIR)/bin/genwqe_memcopy
	install -D -m 755 genwqe_echo      -T $(DESTDIR)/bin/genwqe_echo
	install -D -m 755 genwqe_peek      -T $(DESTDIR)/bin/genwqe_peek
	install -D -m 755 genwqe_poke      -T $(DESTDIR)/bin/genwqe_poke
	install -D -m 755 genwqe_cksum     -T $(DESTDIR)/bin/genwqe_cksum
	install -D -m 755 genwqe_vpdconv   -T $(DESTDIR)/bin/genwqe_vpdconv
	install -D -m 755 genwqe_vpdupdate -T $(DESTDIR)/bin/genwqe_vpdupdate
	install -D -m 755 genwqe_csv2vpd   -T $(DESTDIR)/bin/genwqe_csv2vpd
	install -D -m 755 genwqe_ffdc      -T $(DESTDIR)/bin/genwqe_ffdc

uninstall: uninstall_gzip_tools uninstall_manpages
	@for f in $(projs) ; do					\
		echo "removing $(DESTDIR)/bin/$$f ...";		\
		$(RM) $(DESTDIR)/bin/$$f;			\
	done

clean distclean:
	$(RM) $(objs) $(projs) $(manpages)

=== debian/changelog ===
genwqe-user (4.0.18-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS. (Closes: #954611)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 10 Apr 2020 14:38:27 +0100

genwqe-user (4.0.18-3) unstable; urgency=medium

  * Change Architecture to linux-any.

 -- Fernando Seiti Furusato <ferseiti@linux.vnet.ibm.com>  Thu, 09 Mar 2017 11:44:34 -0300

genwqe-user (4.0.18-2) unstable; urgency=medium

  * Add patches that fix FTBFS on 32-bit architectures (Closes: #855377)

 -- Fernando Seiti Furusato <ferseiti@linux.vnet.ibm.com>  Wed, 08 Mar 2017 08:43:51 -0300

genwqe-user (4.0.18-1) unstable; urgency=medium

  * Initial release (Closes: #826774)

 -- Fernando Seiti Furusato <ferseiti@linux.vnet.ibm.com>  Thu, 12 Jan 2017 13:18:16 -0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# Destination directory where files will be installed
INSTDIR = $(CURDIR)/debian/tmp

VERSION=$(DEB_VERSION_UPSTREAM)

%:
	dh $@ 

override_dh_auto_clean:
	$(MAKE) distclean V=2
	$(RM) cantrbry.tar.gz

override_dh_auto_build:
# The tarball below is a workaround so the test does not need to
# download it.
	tar czvf cantrbry.tar.gz -C misc .
	$(MAKE) tools lib VERSION=$(VERSION) V=2

override_dh_auto_install:
	dh_auto_install -- \
	  DESTDIR=$(INSTDIR)/usr \
	  LIB_INSTALL_PATH=$(INSTDIR)/usr/lib/$(DEB_HOST_MULTIARCH) \
	  INCLUDE_INSTALL_PATH=$(INSTDIR)/usr/include/genwqe \
	  MAN_INSTALL_PATH=$(INSTDIR)/usr/share/man/man1
# The symlinks below are the alternatives to gzip and gunzip.
	ln -srf $(INSTDIR)/usr/bin/genwqe_gunzip \
          $(INSTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/gunzip
	ln -srf $(INSTDIR)/usr/bin/genwqe_gzip \
          $(INSTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/gzip

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/<project>-$1.tar.gz/" \
  https://github.com/ibm-genwqe/genwqe-user/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## genwqe-user 4.0.20

=== lib/Makefile ===
#
# Copyright 2015, International Business Machines
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include ../config.mk

zlibver=1.2.8
libversion = $(VERSION)

CFLAGS += -fPIC -fno-strict-aliasing
LDLIBS += -lpthread -ldl -lrt

# If we use libcxl, we need to reflect that to avoid underlinkage
ifeq ($(WITH_LIBCXL),1)
ifneq ($(BUNDLE_LIBCXL),1)
LDLIBS += -lcxl
endif
endif

### Accelerated libz implementation (Accelerated Data Compression/ADC)
libname=libzADC
projA = $(libname).a \
	$(libname).so \
	$(libname).so.$(MAJOR_VERS) \
	$(libname).so.$(libversion)

src = wrapper.c hardware.c software.c
objs = __libzHW.o __libcard.o __libDDCB.o $(src:.c=.o)

### libzHW
src0 = libzHW.c inflate.c deflate.c
libname0 = libzHW
proj0 = $(libname0).a $(libname0).so.$(libversion) $(libname0).so
objs0 = $(src0:.c=.o)

### libcard
src1 = libcard.c
libname1 = libcard
proj1 = $(libname1).a $(libname1).so.$(libversion) $(libname1).so
objs1 = $(src1:.c=.o)

### libDDCB requires libcxl for CAPI support
src2 += libddcb.c ddcb_card.c

# ddcb_capi is only used with LIBCXL support.
ifdef WITH_LIBCXL
src2 += ddcb_capi.c
endif

libname2 = libDDCB
proj2 = $(libname2).a $(libname2).so.$(libversion) $(libname2).so
objs2 = $(src2:.c=.o)

projs += $(projA) $(proj0) $(proj1) $(proj2)

all: $(projs)

ifdef WITH_LIBCXL

ddcb_capi.o: $(libcxl_a)

$(libcxl_a): ..check_libcxl
	$(MAKE) -C $(CONFIG_LIBCXL_PATH)

.PHONY: ..check_libcxl
..check_libcxl:
	@if [ $(BUNDLE_LIBCXL) -eq 1 ]; then				\
	  if [ ! -d $(CONFIG_LIBCXL_PATH) ]; then 			\
	    printf  "\t[ERROR]\t$(CONFIG_LIBCXL_PATH) not found!\n";	\
	    echo;							\
	    echo "  Please clone libcxl git before continuing:";	\
	    echo "    git clone https://github.com/ibm-capi/libcxl";	\
	    echo;							\
	    exit 1;							\
	  fi;								\
	  if [ ! -f $(CONFIG_LIBCXL_PATH)/include/misc/cxl.h ]; then	\
	    printf  "\t[ERROR]\t$(CONFIG_LIBCXL_PATH)/include/misc/cxl.h not found!\n";\
	    echo;							\
	    echo "  Please ensure you are having up-todate";		\
	    echo "  kernel-headers when building the code.";		\
	    echo "  When using pslse, get a recent copy of the file";	\
	    echo "  from kernel.org and copy the file manually to";	\
	    echo "  $(CONFIG_LIBCXL_PATH)/include/misc/cxl.h.";		\
	    echo;							\
	    exit 1;							\
	  fi								\
	fi

endif	# WITH_LIBCXL

### libzHW
__$(libname0).o: $(objs0)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname0).a: __$(libname0).o
	$(AR) rcs $(ARFLAGS) $@ $^

$(libname0).so: $(libname0).so.$(libversion)
	ln -sf $< $@

$(libname0).so.$(libversion): __$(libname0).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^

### libcard
__$(libname1).o: $(objs1)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname1).a: __$(libname1).o
	$(AR) rcs $(ARFLAGS) $@ $^

$(libname1).so: $(libname1).so.$(libversion)
	ln -sf $< $@

$(libname1).so.$(libversion): __$(libname1).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^

### libDDCB
__$(libname2).o: $(objs2) $(libcxl_a)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname2).a: __$(libname2).o
	$(AR) rcs $(ARFLAGS) $@ $^

$(libname2).so: $(libname2).so.$(libversion)
	ln -sf $< $@

$(libname2).so.$(libversion): __$(libname2).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^

### libzADC
__$(libname).o: $(objs) $(libz_a)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname).a: __$(libname).o
	$(AR) rcs $@ $^

$(libname).so:  $(libname).so.$(libversion)
	ln -sf $< $@

$(libname).so.$(MAJOR_VERS): $(libname).so.$(libversion)
	ln -sf $< $@

$(libname).so.$(libversion): __$(libname).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$(libname).so.$(MAJOR_VERS) \
		 -Wl,--version-script=libzADC.map -o $@ $^ $(LDLIBS)

# Produce z_ prefixed version of software zlib. We need this when we
# want to include libz statially instead of using dlopen/dlsym to use
# it.
#
# Special version of libz.a which has z_ prefixed function
# names. Required for software zlib fallback in case of small buffers
# and accelerator unavailability.
#
libz_prefixed.o:

zlib_objs = $(CONFIG_LIBZ_PATH)/adler32.lo  \
	    $(CONFIG_LIBZ_PATH)/infback.lo  \
	    $(CONFIG_LIBZ_PATH)/compress.lo \
	    $(CONFIG_LIBZ_PATH)/gzclose.lo  \
	    $(CONFIG_LIBZ_PATH)/inffast.lo  \
	    $(CONFIG_LIBZ_PATH)/trees.lo    \
	    $(CONFIG_LIBZ_PATH)/crc32.lo    \
	    $(CONFIG_LIBZ_PATH)/gzlib.lo    \
	    $(CONFIG_LIBZ_PATH)/inflate.lo  \
	    $(CONFIG_LIBZ_PATH)/uncompr.lo  \
	    $(CONFIG_LIBZ_PATH)/deflate.lo  \
	    $(CONFIG_LIBZ_PATH)/gzread.lo   \
	    $(CONFIG_LIBZ_PATH)/inftrees.lo \
	    $(CONFIG_LIBZ_PATH)/zutil.lo    \
	    $(CONFIG_LIBZ_PATH)/gzwrite.lo

libz_prefixed.o: libz.o
	$(OBJCOPY) --prefix-symbols=z_ $< $@

libz.o: $(CONFIG_LIBZ_PATH)/libz.so
	$(LD) $(XLDFLAGS) -r -o $@ $(zlib_objs)

install: install_zlib

install_zlib: all
	mkdir -p $(LIB_INSTALL_PATH)
	cp -auv $(projA) $(LIB_INSTALL_PATH)
	(cd $(LIB_INSTALL_PATH) && \
		ln -sf $(libname).a libz.a && \
		ln -sf $(libname).so.$(libversion) libz.so && \
		ln -sf $(libname).so.$(libversion) libz.so.1)
	mkdir -p $(INCLUDE_INSTALL_PATH)
	cp -uv ../include/zaddons.h $(INCLUDE_INSTALL_PATH)

uninstall:
	@echo "removing $(INCLUDE_INSTALL_PATH) $(LIB_INSTALL_PATH)"
	$(RM) -r $(INCLUDE_INSTALL_PATH) $(LIB_INSTALL_PATH)

# general things
%.o: %.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
	$(CC) -MM $(CPPFLAGS) $(CFLAGS) $< > $*.d

clean distclean:
	$(RM) *.o *.d $(projs) *.so *.so.*
ifneq ($(CONFIG_LIBCXL_PATH),)
	$(MAKE) -C $(CONFIG_LIBCXL_PATH) $@
endif

-include $(objs:.o=.d) $(objs0:.o=.d) $(objs1:.o=.d) $(objs2:.o=.d)

=== misc/Makefile ===
#
# Copyright 2016, International Business Machines
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include ../config.mk

LDLIBS += -lzADC
LDFLAGS += -L../lib -Wl,-rpath,lib

zpipe_mt_libs = -lpthread

projs = zpipe zpipe_mt zpipe_append zpipe_rnd

all: $(projs)

$(projs): $(libs)

### Deactivate existing implicit rule
%: %.c
%: %.sh

### Generic rule to build a tool
%: %.o
	$(CC) $(LDFLAGS) $@.o $($(@)_objs) $($(@)_libs) $(LDLIBS) -o $@

%.o: %.c $(libs)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

install uninstall:
	@echo "Nothing to be done here."

clean distclean:
	$(RM) $(objs) $(projs) $(manpages)

=== tools/Makefile ===
--- 
+++ 
@@ -19,6 +19,10 @@
 DESTDIR ?= /usr
 libs = ../lib/libDDCB.a ../lib/libzHW.a ../lib/libcard.a
 LDLIBS += $(libs) -lpthread -lrt
+
+ifeq ($(BUILD_AGZIP_TOOLS),1)
+LDLIBS += -ljson-c
+endif
 
 genwqe_peek_objs = force_cpu.o
 genwqe_poke_objs = force_cpu.o
@@ -42,6 +46,11 @@
 ifdef WITH_LIBCXL
 # genwqe_maint is only used with CAPI support.
 projs += genwqe_maint genwqe_loadtree
+
+ifeq ($(BUILD_AGZIP_TOOLS),1)
+projs += agzipd ag_uptime
+endif
+
 CAPI_INSTALL=capi_install
 
 # If we are bundling, we need to link statically.  Otherwise, go dynamic.
@@ -62,7 +71,9 @@
 
 objs = force_cpu.o genwqe_vpd_common.o $(projs:=.o)
 
-manpages = $(projs:=.1.gz)
+test_scripts = genwqe_mt_perf genwqe_test_gz
+
+manpages = $(projs:=.1.gz) $(test_scripts:=.1.gz)
 
 manpages: all $(manpages)
 
@@ -83,6 +94,7 @@
 ### Setting LD_LIBRARY_PATH helps to try tools with dynamic linkage
 %.1: %
 	LD_LIBRARY_PATH=../lib $(HELP2MAN) -N --output=$@ \
+		--help-option='-h' --version-option='-V' \
 		--name "IBM Hardware Accelerator Tool." ./$<
 
 %.1.gz: %.1

=== debian/changelog ===
genwqe-user (4.0.20-3) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Exclude i386 build from Salsa CI

  [ наб ]
  * d/p/shuf: Fix Makefile dependencies (Closes: #1105333)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 24 Aug 2025 19:29:14 +0200

genwqe-user (4.0.20-2) unstable; urgency=medium

  * Team upload.
  * Build-Depends: architecture-is-64-bit

 -- Andreas Tille <tille@debian.org>  Wed, 19 Feb 2025 10:03:06 +0100

genwqe-user (4.0.20-1) unstable; urgency=medium

  * Team upload.

  [ наб ]
  * d/watch: version 4
  * New upstream version 4.0.20 (Closes: #1087553, #1069483)
    + Rebase patches
    + d/not-installed: add, listing /u/l/*/**.a
  * debian/libzadc4.symbols: add zedc_read_pending_output@Base 4.0.20
                               & z_compressBound@Base 4.0.20
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * d/control: Homepage: https://github.com/ibm-genwqe/genwqe-user
  * Also forward VERSION and CROSS in dh_auto_test & dh_auto_install
  * d/control: drop versioned zlib restriction unneeded since wheezy
  * Vcs-Git: https://salsa.debian.org/debian/genwqe-user.git
    Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
    Closes: #1088623

  [ Helmut Grohne ]
  * Pass CROSS to fix cross-builds (Closes: #961947)
    (it still doesn't cross-build because it uses help2man, but)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Thu, 28 Nov 2024 19:34:19 +0100

=== debian/control ===
Source: genwqe-user
Priority: optional
Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
Build-Depends: debhelper-compat (= 13),
               architecture-is-64-bit,
               help2man,
               zlib1g-dev,
               libcxl-dev [ppc64el]
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/ibm-genwqe/genwqe-user
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/genwqe-user.git
Vcs-Browser: https://salsa.debian.org/debian/genwqe-user

Package: libzadc-dev
Section: libdevel
Architecture: linux-any
Depends: libzadc4 (= ${binary:Version}), ${misc:Depends}, zlib1g-dev
Description: accelerated libz implementation (development headers)
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides headers and development libraries.

Package: libzadc4
Section: libs
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, zlib1g
Description: accelerated libz implementation (Accelerated Data Compression/ADC)
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides public libzADC library, and libz library
 symlinks which are not exposed in the ldconfig paths.

Package: genwqe-tools
Section: utils
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, zlib1g
Description: utilities for accelerated libz implementation
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides utilities to use libzADC, as well as
 gzip/gunzip names for genwqe utilities in a subdirectory not in
 $PATH.

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 VERSION=$(DEB_VERSION_UPSTREAM)
 
 %:
-	dh $@ 
+	dh $@
 
 override_dh_auto_clean:
 	$(MAKE) distclean V=2
@@ -21,14 +21,18 @@
 # The tarball below is a workaround so the test does not need to
 # download it.
 	tar czvf cantrbry.tar.gz -C misc .
-	$(MAKE) tools lib VERSION=$(VERSION) V=2
+	$(MAKE) tools lib VERSION=$(VERSION) V=2 $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,CROSS=$(DEB_HOST_GNU_TYPE)-)
+
+override_dh_auto_test:
+	dh_auto_test -- VERSION=$(VERSION) V=2 $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,CROSS=$(DEB_HOST_GNU_TYPE)-)
 
 override_dh_auto_install:
 	dh_auto_install -- \
 	  DESTDIR=$(INSTDIR)/usr \
 	  LIB_INSTALL_PATH=$(INSTDIR)/usr/lib/$(DEB_HOST_MULTIARCH) \
 	  INCLUDE_INSTALL_PATH=$(INSTDIR)/usr/include/genwqe \
-	  MAN_INSTALL_PATH=$(INSTDIR)/usr/share/man/man1
+	  MAN_INSTALL_PATH=$(INSTDIR)/usr/share/man/man1 \
+	  VERSION=$(VERSION) V=2 $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,CROSS=$(DEB_HOST_GNU_TYPE)-)
 # The symlinks below are the alternatives to gzip and gunzip.
 	ln -srf $(INSTDIR)/usr/bin/genwqe_gunzip \
           $(INSTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/gunzip

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
  https://github.com/ibm-genwqe/genwqe-user/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
